%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Created_Coord_ID = DB_Coord_Create_Rect_3P(Location_1, Location_2, Location_3)

% Счетчик db_Next_Coord_Number обновляется вне данной функции после ее вызова
% Если Location_i - столбец координат, то он предполагается в ГЛОБАЛЬНОЙ системе координат
% Если Location_i - номер существующего узла, то новый узел будет создан в той же точке

global db_Next_Coord_Number;
global ErrCode;

global DB_COORD;
global DB_NODES;

global AST_COORD;

global AT_NODES;
global AT_COORD;

global AT_Page_Prealloc_Size;
global CID_Vector_zero_tolerance;

Created_Coord_ID = [];

% Проверка существования в базе системы координат со следующим номером
if (DB_Coord_Exist(db_Next_Coord_Number))
    fprintf (1, '\nОшибка функции DB_Coord_Create_Rect_3P: система координат с номером %i уже существует в базе !\n', db_Next_Coord_Number);
    ErrCode = -1;
    return;
end

% Проверка существования в базе референсных узлов
if (size(Location_1,1) == 1)
    if (~DB_Node_Exist(Location_1))
        fprintf (1, '\nОшибка функции DB_Coord_Create_Rect_3P: референсный узел с номером %i отсутствует в базе !\n', Location_1);
        ErrCode = -1;
        return;
    end
end

if (size(Location_2,1) == 1)
    if (~DB_Node_Exist(Location_2))
        fprintf (1, '\nОшибка функции DB_Coord_Create_Rect_3P: референсный узел с номером %i отсутствует в базе !\n', Location_2);
        ErrCode = -1;
        return;
    end
end

if (size(Location_3,1) == 1)
    if (~DB_Node_Exist(Location_3))
        fprintf (1, '\nОшибка функции DB_Coord_Create_Rect_3P: референсный узел с номером %i отсутствует в базе !\n', Location_3);
        ErrCode = -1;
        return;
    end
end

% Заполнение координат референсных точек
if (size(Location_1,1) == 3)
	Point_1 = Location_1;
else
    Point_1 = DB_NODES{AT_NODES(Location_1)}.Location;
end

if (size(Location_2,1) == 3)
	Point_2 = Location_2;
else
    Point_2 = DB_NODES{AT_NODES(Location_2)}.Location;
end

if (size(Location_3,1) == 3)
	Point_3 = Location_3;
else
    Point_3 = DB_NODES{AT_NODES(Location_3)}.Location;
end

% Проверка точек
if (Equiv_Check_Cube(Point_1, Point_2) || Equiv_Check_Cube(Point_2, Point_3) || Equiv_Check_Cube(Point_1, Point_3))
    fprintf (1, '\nОшибка функции DB_Coord_Create_Rect_3P: обнаружены совпадающие референсные точки !\n');
    ErrCode = -1;
    return;
end

% Нахождение и проверка базисных векторов
e3 = Point_2 - Point_1;
e2 = cross(Point_2 - Point_1, Point_3 - Point_1);

if (norm(e2) < CID_Vector_zero_tolerance)
    fprintf (1, '\nОшибка функции DB_Coord_Create_Rect_3P: референсные точки лежат на одной прямой !\n');
    ErrCode = -1;
    return;
end

e1 = cross(e2, e3);

e1 = e1 / norm(e1);
e2 = e2 / norm(e2);
e3 = e3 / norm(e3);

% Выделение памяти
if (isempty(DB_COORD))
    AT_COORD = zeros(AT_Page_Prealloc_Size,1,'uint64');
end
if (db_Next_Coord_Number >= size(AT_COORD,1))
    AT_COORD(db_Next_Coord_Number + AT_Page_Prealloc_Size,1) = 0;
end

% Следующий индекс в базе
Next_DB_index = size(DB_COORD,1) + 1;

% Создание записи в базе
DB_COORD{Next_DB_index,1}.ID = db_Next_Coord_Number;
DB_COORD{Next_DB_index,1}.type = 'Rectangular';
DB_COORD{Next_DB_index,1}.e_x = e1;
DB_COORD{Next_DB_index,1}.e_y = e2;
DB_COORD{Next_DB_index,1}.e_z = e3;
DB_COORD{Next_DB_index,1}.origin = Point_1;

% % Создание записи в таблице ассоциативности систем координат
% AST_COORD{Next_DB_index,1}.Node_list = [];
% AST_COORD{Next_DB_index,1}.PSet_list = [];

% Создание ссылки в адресной таблице
AT_COORD(db_Next_Coord_Number) = Next_DB_index;

% Номер созданной системы координат
Created_Coord_ID = db_Next_Coord_Number;
